﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Fei.BaseLib;
using System.Collections;

namespace inptp_2010_cviko_11 {
    public partial class MainForm : Form {
        private IntSeznam seznam = new IntSeznam();
        private CeleCisloDialog celeCisloDialog = new CeleCisloDialog();

        public MainForm() {
            //            ISeznam iseznam = seznam;
            //           iseznam.Pridej("pozdrav");
            InitializeComponent();
            if (components == null) {
                components = new Container();
            }
            components.Add(celeCisloDialog);

            //         seznam.PridejNaKonec("pozdrav");
        }

        private void ukoncitMenuItem_Click(object sender, EventArgs e) {
            Close();
        }

        private void generovatMenuItem_Click(object sender, EventArgs e) {
            Random random = new Random();
            const int pocet = 20;
            const int minHodnota = 1;
            const int maxHodnota = 100;
            seznam.VymazVse();
            for (int i = 0; i < pocet; i++) {
                seznam.PridejNaKonec(random.Next(minHodnota, maxHodnota));
            }
            naplnListBox(seznam);
        }
        private void naplnListBox(IEnumerable kolekce) {
            cislaListBox.Items.Clear();
            foreach (object item in kolekce) {
                cislaListBox.Items.Add(item);
            }
        }

        private void pridatNaKonecMenuItem_Click(object sender, EventArgs e) {
            if (celeCisloDialog.ShowDialog() == DialogResult.OK) {
                seznam.PridejNaKonec(celeCisloDialog.Cislo);
                cislaListBox.Items.Add(celeCisloDialog.Cislo);
            }
        }

        private void pridatNaZacatekMenuItem_Click(object sender, EventArgs e) {
            if (celeCisloDialog.ShowDialog() == DialogResult.OK) {
                seznam.PridejNaZacatek(celeCisloDialog.Cislo);
                cislaListBox.Items.Insert(0, celeCisloDialog.Cislo);
            }
        }

        private void vymazatMenuItem_Click(object sender, EventArgs e) {
            if (cislaListBox.SelectedItems.Count == 0) {
                Hlaseni.Chyba("Není vybráno žádné číslo");
                return;
            }
            while (cislaListBox.SelectedItems.Count > 0) {
                seznam.Vymaz(cislaListBox.SelectedItems[0]);
                cislaListBox.Items.RemoveAt(cislaListBox.SelectedIndices[0]);
            }
        }

        private void seraditMenuItem_Click(object sender, EventArgs e) {
            seznam.Serad();
            naplnListBox(seznam);
        }

        private static void odstranDuplicitu(ISeznam seznam) {
            int pocet;
            Seznam pomocnySeznam = new Seznam();
            foreach (object item in seznam) {
                pocet = 0;
                if(!pomocnySeznam.Obsahuje(item)) {
                    foreach (object item2 in seznam) {
                        if(item.Equals(item2) {
                            pocet++;
                            if(pocet > 1) {
                                pomocnySeznam.PridejNaKonec(item2);
                            }
                        }
                    }
                }
            }
            foreach (object item in pomocnySeznam) {
                seznam.Vymaz(item);
            }
	{
		 
	}
        }

        private void vymazatDuplicitníPrvkyMenuItem_Click(object sender, EventArgs e) {
            odstranDuplicitu(seznam);
            naplnListBox(seznam);
        }
    }
}
